﻿Type=Class
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
 Sub Class_Globals
	Public Pages(1) As Panel
	Private cmdButtons(1) As ToggleButton
	Private ParentAct As Activity
	Private PageCount As Int
	Private SelectedPage As Int
	Private TopPanel As Panel
	Private BasePanel As Panel
	Private BasePanelHost As Panel
	Private OverPanel As Panel
	Private StartLeft As Double
	Private GD As GestureDetector
	Dim StartX      As Float                      
   	Dim SoftKey      As IME                            
End Sub

'Initializes the object
Public Sub Initialize(vActivity As Activity ,  vPages As Int)
	
	Public Pages(vPages) As Panel
	Private cmdButtons(vPages) As ToggleButton
	ParentAct = vActivity
	PageCount = vPages
	SelectedPage=0

	SoftKey.Initialize("") 
	
	OverPanel.Initialize("OverPanel")
	

	BasePanel.Initialize("BasePanel")
	BasePanelHost.Initialize("BasePanelHost")
	BasePanelHost.Color = Colors.DarkGray

	
	ParentAct.AddView(BasePanelHost,0,40dip,100%x,100%y-40dip)
	BasePanelHost.AddView(BasePanel,0,0,vActivity.Width*vPages,100%y)
	
	TopPanel.Initialize("")
	Dim bg1 As ColorDrawable
	bg1.Initialize(Colors.Gray,0)
	TopPanel.Background = bg1
	ParentAct.AddView(TopPanel,0,0,100%x,40dip)

	For k=0 To PageCount-1
		Pages(k).Initialize("Pages") 
		Pages(k).Visible = True
		cmdButtons(k).Initialize("cmdButtons")
		cmdButtons(k).Tag = k
		TopPanel.AddView(cmdButtons(k), k*(100%x/PageCount)-5dip, 0, (100%x/PageCount)+10dip, 40dip)
	    BasePanel.AddView(Pages(k), ParentAct.Width*k, 0, ParentAct.Width, 100%y)
	Next
	ParentAct.AddView(OverPanel,0,40dip,100%x,100%y-40dip)

	OverPanel.BringToFront
	
	GD.SetOnGestureListener(OverPanel,"GDoverpanel")
	cmdButtons(0).Checked = True
End Sub



public Sub InitPage(vPageNum As Int, vLayout As String,vMenuName As String)
	Pages(vPageNum).LoadLayout(vLayout)
	cmdButtons(vPageNum).TextOn = vMenuName
	cmdButtons(vPageNum).TextOff = vMenuName
End Sub

public Sub SelectPage(vPage As Int)
cmdButtons(SelectedPage).Checked = False
BasePanel.Left = -ParentAct.Width*vPage
cmdButtons(vPage).Checked = True
SelectedPage=vPage
End Sub

Sub cmdButtons_Click
	Dim bb As ToggleButton
	bb = Sender
	SelectPage ( bb.Tag)
End Sub



Sub GDoverpanel_onTouch(Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Log("X: " & x & ",  Y: " & y)
	
   Select Action
	   	
   Case GD.ACTION_DOWN                                     
        StartX    = x
		StartLeft = BasePanel.Left

   Case GD.ACTION_MOVE
	  	BasePanel.Left = StartLeft + X - StartX                                       

   Case GD.ACTION_UP  
		'
   End Select
	
	Return GD.PassTouchEventTo(MotionEvent,BasePanelHost)
End Sub




